/*                                        
 * 	NiceShaper - Dynamic Traffic Management                                                                                                                           
 * 	
 * 	Copyright 2004 Mariusz Jedwabny <mariusz@jedwabny.net>                                                                                                             
 *                                                                                                                                                                                 
 * 	This file is subject to the terms and conditions of the GNU General Public                                                                                                      
 * 	License.  See the file COPYING in the main directory of this archive for                                                                                                        
 * 	more details.                                                                                                                                                                   
 */      

#include "aux.h"

long int power( int val , int inc )                                                                                                                          
{                                                                                                                                                            
    long int result = 1;                                                                                                                                       
	for ( int n = 1; n <= inc ; n++ ) result = result * val;                                                                                                   
    return result;                                                                                                                                             
}                                                                                                                                                            
			                                                                                                                                                               
unsigned int compute_quantum ( unsigned int rate )                                                                                                           
{                                                                                                                                                            
    unsigned int quantum=rate/8/1500;                                                                                                                        
    if (!quantum) quantum=1;                                                                                                                                 
    return quantum;                                                                                                                                          
}                      

                                                                                                                                                             
long int unitconvert(char arg[], unittype resunit)                                                                                                           
{                                                                                                                                                            
    return ((atol(arg) * (long int) getunit(arg)) / (long int) resunit);                                                                                     
}                                                                                                                                                            
                                                                                                                                                                 
long int unitconvert(long int arg, unittype resunit)                                                                                                         
{                                                                                                                                                            
    return (arg / (long int) resunit);                                                                                                                       
}   

int trim(char buf[])
{
    int dl;

    dl=strlen(buf);
    for ( int n=0; n<dl; n++ ) {
	if ( buf[n]==9 ) buf[n]=32;
	else if ( buf[n]==35) buf[n]=0;
	else if ( buf[n]==10) buf[n]=0;
    }
    while ( buf[0]==32 ) {
	dl=strlen(buf);
	for ( int m=0; m<(dl-1); m++ ) buf[m]=buf[m+1];
	buf[dl-1]=0;
    }
    dl=strlen(buf)-1;
    for ( int n=dl; n>=0; n-- ) {
	if (buf[n]==32) buf[n]=0;
	else break;
    }
    dl=strlen(buf);
    for ( int n=0; n<dl; n++ ) {
	if ( buf[n]==32 ) {
	    while ( buf[n+1]==32 ) {
		for ( int m=n; m<dl; m++ ) buf[m] = buf[m + 1];
	    }
	}
	if ((buf[n] >= 97) || (buf[n] <= 122)) continue;
	else if ((buf[n] >= 65) || (buf[n] <= 90)) continue;
	else if ((buf[n] >= 48) || (buf[n] <= 57)) continue;
	else if ((buf[n] == 43) || (buf[n] == 45)) continue;
	else if ((buf[n] == 60) || (buf[n] == 62) || (buf[n] == 46) || (buf[n] == 47)) continue;
	else {
	    printf( "\tforbidden char (%c):%s\n", buf[n], buf );
	    return -1;
	}
    }
    
    return 0;
}

int dotobit( char mask[] )
{
  unsigned long addr;
  int n, bit;

  addr=ntohl( inet_addr(mask));
  for ( n=0, bit=0; n<32; n++ )
    bit += (addr>>n)&1;
  return bit;
}

bool bitodot(char mask[], int arg)
{
  struct in_addr netwrk;
  int n, m;

  if (arg < 0 || arg > 32) return false;
  for (m = 0, n = 0; n < arg; n++) m += 1 << (31 - n);
  netwrk.s_addr = htonl(m);
  strcpy( mask, inet_ntoa(netwrk));
  mask[strlen(mask)] = '\0';
  return true;
}

char *awk(char param[], unsigned int word)
{
    unsigned int n, aku;
    char buf[128];
    static char result[128];
    unsigned int paramlength;

    aku = 0;
    strcpy(buf, "");
    strcpy(result, "");
    paramlength = strlen(param);    
    for (n = 0; n + 1 < paramlength; n++) {
	if ((param[n] == 32 || param[n] == 9) && (param[n + 1] != 32 && param[n + 1] != 9)) aku++;
	if (n == 0 && param[0] != 32 && param[0] != 9) aku++;
	if (aku == word) {
	    if (n == 0 && param[0] != 32 && param[0] != 9)
	    strcpy(buf, param);
	else
	    strcpy(buf, &(param)[n + 1]);
	    break;	    
	}
    }
    paramlength = strlen(buf);
    for (n = 0; n < paramlength; n++) {
	if (buf[n] == 32 || buf[n] == 9 || buf[n] == 10) {
	    buf[n] = '\0';
	    break;
	}
    }
    strcpy(result, buf);
    
    return result;
}

char *awk2(char param[], unsigned int word)
{
    unsigned int n, aku;
    char buf[128];
    static char result[128];

    aku = 0;
    strcpy(buf, "");
    strcpy(result, "");
    unsigned int paramlength = strlen(param);        
    for (n = 0; n + 1 < paramlength; n++) {
	if ((param[n] == 32 || param[n] == 9) && (param[n + 1] != 32 && param[n + 1] != 9)) aku++;
	if (n == 0 && param[0] != 32 && param[0] != 9) aku++;
	if (aku == word) {
	    if (n == 0 && param[0] != 32 && param[0] != 9)
	    strcpy(buf, param);
	else
	    strcpy(buf, &(param)[n + 1]);
	    break;
	}
    }
    for (n = 0; n < strlen(buf); n++) {
	if (buf[n] == 32 || buf[n] == 9 || buf[n] == 10) {
	    buf[n] = '\0';
	    break;	    
	}
    }
    strcpy(result, buf);
    
    return result;
}

enum unittype getunit(char arg[])
{
    if ( strstr( arg, "kbit" )) return kbit;
    else if ( strstr( arg, "mbit" )) return mbit;
    else if ( strstr( arg, "bit" )) return bit;

    else if ( strstr( arg, "kB" )) return kbps;
    else if ( strstr( arg, "KB" )) return kbps;
    else if ( strstr( arg, "mB" )) return mbps;
    else if ( strstr( arg, "MB" )) return mbps;
    else if ( strstr( arg, "B" )) return bps;

    else if ( strstr( arg, "kbps" )) return kbit;
    else if ( strstr( arg, "mbps" )) return mbit;
    else if ( strstr( arg, "bps" )) return bit;

    else if ( strstr( arg, "kBps" )) return kbps;
    else if ( strstr( arg, "KBps" )) return kbps;
    else if ( strstr( arg, "mBps" )) return kbps;
    else if ( strstr( arg, "MBps" )) return mbps;
    else if ( strstr( arg, "Bps" )) return bps;

    else if ( strstr( arg, "kb/s" )) return kbit;
    else if ( strstr( arg, "mb/s" )) return mbit;
    else if ( strstr( arg, "b/s" )) return bit;

    else if ( strstr( arg, "kB/s" )) return kbps;
    else if ( strstr( arg, "KB/s" )) return kbps;
    else if ( strstr( arg, "mB/s" )) return mbps;
    else if ( strstr( arg, "MB/s" )) return mbps;
    else if ( strstr( arg, "B/s" )) return bps;

    else {
	return bit;
    }	
}

int gen_ipt_filter ( char ipt_match[], char match[])
{
    bool blank;

    return gen_ipt_filter ( blank, ipt_match, match );
}

int gen_ipt_filter ( bool &need_mark, char result[], char src[])
{
    char param[SHORT_BUF], value[SHORT_BUF];
    char addr[SHORT_IP_ADDR+1], mask[SHORT_IP_ADDR+1];
    bool proto_defined=false;
    unsigned int n;
    
    need_mark = false;

    // owner, lenght, tcpflag , ack
    
    n=0;
    while ( strlen( awk( src, ++n ))) { 
        strcpy ( param, awk( src, n ));                                                                                                                      
	strcpy ( value, awk( src, ++n ));     
        if ( !strcmp( param, "proto" )) {
	    strcat( result, " -p " );
	    strcat( result, value );
    	    strcat( result, " " );
	    proto_defined=true;
	}
    }
    
    n=0;
    while ( strlen( awk( src, ++n ))) { 
        strcpy ( param, awk( src, n ));                                                                                                                      
	strcpy ( value, awk( src, ++n ));     

	if ( !strcmp( param, "srcip" )) {
    	    if ( split( addr, mask, value ) == -1 ) return -1;
    	    strcat( result, " -s " );
    	    strcat( result, addr );
    	    strcat( result, "/" );
	    strcat( result, mask );
            strcat( result, " " );	
	}
	else if ( !strcmp( param, "dstip" )) {
	    if ( split( addr, mask, value ) == -1 ) return -1;
    	    strcat( result, " -d " );
    	    strcat( result, addr );
    	    strcat( result, "/" );
    	    strcat( result, mask );
    	    strcat( result, " " );	
	}
	else if ( !strcmp( param, "not-srcip" )) {
    	    if ( split( addr, mask, value ) == -1 ) return -1;
    	    strcat( result, " ! -s " );
    	    strcat( result, addr );
    	    strcat( result, "/" );
	    strcat( result, mask );
            strcat( result, " " );
            need_mark = true;
	}
	else if ( !strcmp( param, "not-dstip" )) {
	    if ( split( addr, mask, value ) == -1 ) return -1;
    	    strcat( result, " ! -d " );
    	    strcat( result, addr );
    	    strcat( result, "/" );
    	    strcat( result, mask );
    	    strcat( result, " " );
    	    need_mark = true;
	}
	else if (( !strcmp( param, "srcport" )) || ( !strcmp( param, "sport" ))) {
	    if ( !proto_defined ) {
		error->dump( 35, src ); 
    		return -1; 
	    }
    	    strcat( result, " --sport " );
            strcat( result, value );
    	    strcat( result, " " );
	}
	else if (( !strcmp( param, "dstport" )) || ( !strcmp( param, "dport" ))) {
	    if ( !proto_defined ) {
		error->dump( 35, src ); 
    		return -1; 
	    }
    	    strcat( result, " --dport " );
            strcat( result, value );
    	    strcat( result, " " );
	}
	else if (( !strcmp( param, "not-srcport" )) || ( !strcmp( param, "not-sport" ))) {
	    if ( !proto_defined ) {
		error->dump( 35, src ); 
    		return -1; 
	    }
    	    strcat( result, " ! --sport " );
            strcat( result, value );
    	    strcat( result, " " );
    	    need_mark = true;
	}
	else if (( !strcmp( param, "not-dstport" )) || ( !strcmp( param, "not-dport" ))) {
	    if ( !proto_defined ) {
		error->dump( 35, src ); 
    		return -1; 
	    }
    	    strcat( result, " ! --dport " );
            strcat( result, value );
    	    strcat( result, " " );
    	    need_mark = true;
	}
	else if ( !strcmp( param, "length" )) {
	    strcat( result, " -m length --length " );
	    strcat( result, value );
	    strcat( result, " " );
	    need_mark = true;    
    	}
	else if ( !strcmp( param, "state" )) {
            if (( strcmp( value, "new")) && ( strcmp( value, "established")) && ( strcmp( value, "related")) && ( strcmp( value, "invalid")) && ( strcmp( value, "untracked"))) {
		    error->dump( 34, src ); 
    		    return -1; 
    	    }
	    strcat( result, " -m state --state " );
	    strcat( result, value );
	    strcat( result, " " );
	    need_mark = true;    
	}
	else if ( !strcmp( param, "tos" )) {
	    strcat( result, " -m tos --tos " );
	    strcat( result, value );
	    strcat( result, " " );
	    need_mark = true;    
    	}
	else if ( !strcmp( param, "ttl-lower" )) {
	    strcat( result, " -m ttl --ttl-lt " );
	    strcat( result, value );
	    strcat( result, " ");
	    need_mark = true;    
	}
	else if ( !strcmp( param, "ttl-greater" )) {
	    strcat( result, " -m ttl --ttl-gt " );
    	    strcat( result, value );
	    strcat( result, " " );
	    need_mark = true;    
	}
        else if ( !strcmp( param, "ttl" )) {
    	    strcat( result, " -m ttl --ttl " );
    	    strcat( result, value );
    	    strcat( result, " " );
	    need_mark = true;    
	}    
	else if ( !strcmp( param, "mark" )) {
	    strcat( result, " -m mark --mark " );
	    strcat( result, value );
	    strcat( result, " " );
	    need_mark = true;    
	}	
        else if (( strcmp( param, "proto" )) && ( strcmp( param, "set-mark" )) 
    	    && ( strcmp( param, "filterid" )) && ( strcmp( param, "to" )) 
    	    && ( strcmp( param, "from" )) && ( strcmp( param, "use-for-fw" ))) 
    	{
    	    error->dump ( 11, src );
	    return -1;     
	}
    }

    return 1;	   												
}

bool getip(char netaddr[], char dev[])
{
    char buf[256];
    FILE *pp;

    strcpy(netaddr, "");
    strcpy(buf, "");
    sprintf(buf, "ip addr show dev %s", dev);
    pp = popen(buf, "r");
    while (fgets(buf, LONG_BUF, pp)) {
	if (!strcmp(awk(buf, 1), "inet")) {
	    strcpy(netaddr, awk(buf, 2));
	    pclose(pp);
	    return true;
	}
    }
    
    pclose(pp);
    return false;
}
void iptohostname(char hostname[MAX_NAME+1], char ipaddr[])
{
    uint32_t addr;
    struct hostent *hp;
  
    strncpy( hostname, "", MAX_IFACE+1 );
    addr=inet_addr(ipaddr);
    hp=gethostbyaddr( (char *) &addr, sizeof(addr), AF_INET );
    if ( hp==NULL ) strncpy( hostname, ipaddr, MAX_NAME );
    else strncpy( hostname, hp->h_name, MAX_NAME );
}

int split(char ipaddr[], char ipmask[], char buf[])
{
    strcpy( ipaddr, "" );
    strcpy( ipmask, "" );
    strncpy( ipaddr, buf, strcspn( buf, "/" ));
    ipaddr[ strcspn( buf, "/" )]=0;
    trim(ipaddr);
    if ( !test->validIp( ipaddr )) { error->dump( 29, buf ); return -1; }
    if ( !strstr( buf, "/" )) strcpy( ipmask, "255.255.255.255" );
    else strcpy( ipmask, &(buf[strcspn( buf, "/" )+1]));
    
    trim(ipmask);
    
    if ( !test->validIp(ipmask)) {
	if ( strlen(ipmask)==0) strcpy( ipmask, "255.255.255.255" );
        else if ( atoi(ipmask)>=0 && atoi(ipmask)<=32 ) bitodot( ipmask, atoi(ipmask));
	else return -1;
    }
    
    return 1;
}

unsigned int read_fw_mark(char buf[])
{
    int base;

    if (( buf[0]==48 ) && ( buf[1]==120 )) base=16;
    else base=10;

    return strtoul(buf,NULL,base);
}

bool is_in_vector ( vector < char * > &fpv, const char pattern[] )
{
    vector < char * >::iterator fpvi;

    fpvi = fpv.begin();  
    while ( fpvi != fpv.end()) {
	if ( !strcmp ( *fpvi, pattern )) return true;
	fpvi++;
    }
    
    return false;
}

int fpv_section_i ( vector < char * >::iterator &fpvi_begin, vector < char * >::iterator &fpvi_end, vector < char * > &fpv, const char section[] )
{
    char section_begin[LONG_BUF]="";
    char section_end[LONG_BUF]="";

    vector < char * >::iterator fpvi;
  
    sprintf(section_begin, "<%s>", section);

    fpvi = fpv.begin();  
    while ( fpvi != fpv.end()) {
	if ( !strcmp ( *fpvi, section_begin )) { fpvi_begin = fpvi; break; };
	fpvi++;
    }
    
    if ( fpvi == fpv.end()) {
	error->dump( 38, section ); 
	return -1;
    }	

    sprintf(section_end, "</%s>", section);
    while ( fpvi != fpv.end()) {
	if ( !strcmp( *fpvi, section_end )) { fpvi_end = fpvi; break; }
	else if ( !strcmp( *fpvi, "</>" )) { fpvi_end = fpvi; break; }
	fpvi++;
    }
    
    if ( fpvi == fpv.end()) {
	error->dump( 39, section ); 
	return -1;
    }

    return 1;
}

void gen_fixed_tc_rateceil_buf (char tc_rateceil_buf[SHORT_BUF], unsigned int htb_rate, unsigned int htb_ceil)
{
   sprintf( tc_rateceil_buf, " rate %d ceil %d ", htb_rate, htb_ceil );
}



