#ifndef TCCLASS_H
#define TCCLASS_H

#include "main.h"
#include "error.h"
#include "filter.h"
#include "sys.h"
#include "tests.h"

class TcClass {
    public:
	TcClass(std::vector < char * > &, std::vector < char * > &); // section_ifaces, mark_ifaces
	~TcClass();
        int store(char[]);
        int prepareTcClass(unsigned int, unsigned int);
	int testParams();
        int envInit();
        unsigned int check(std::vector < char * > &, struct timeval, float);
	int add();
        int del();
        int computeTcChanges();    
        int applyChanges();    
        int writeChanges(int);    
        void stats(int, statsclassestype);
        bool work() { return Work; }
        bool sumInSection() { return SumInSection; }
        unsigned int rate() { return Rate; }
        unsigned int htbCeil() { return HtbCeil; }
        unsigned int nsLow() { return NsLow; }
        unsigned int nsCeil() { return NsCeil; }
        unsigned int hardLimit() { return HardLimit; }
        unsigned int softLimit() { return SoftLimit; }
        void decHtbCeil( unsigned int decrease ) { HtbCeil -= decrease; }
        void incHtbCeil( unsigned int increase ) { HtbCeil += increase; }
        void setHtbCeil( unsigned int htb_ceil ) { HtbCeil = htb_ceil; }
        void setHardLimit( unsigned int hard_limit ) { HardLimit = hard_limit; }
        void computeSoftLimit() { SoftLimit = NsLow + (unsigned int)((double)(HardLimit - NsLow) * Strict); }
        void setRate( unsigned int rate ) { Rate = rate; }
    private:
        char Dev[MAX_IFACE+1];
        char Name[MAX_NAME+1];
        char TcClassAdd[LONG_BUF];
        char TcQdiscAdd[LONG_BUF];
        char TcClassDel[LONG_BUF];
        char TcQdiscDel[LONG_BUF];
        char EsfqHash[SHORT_BUF];
        char MlBuf[LONG_BUF];
        char MsBuf[SHORT_BUF];
        unsigned int ClassId;
        unsigned long int Alive;
        unsigned int Hold;
        unsigned int Prio;
        unsigned int NsLow;
        unsigned int NsCeil;
        unsigned int HtbRate;
        unsigned int HtbCeil;
        unsigned int HtbPrio;
        unsigned int OldHtbRate;
        unsigned int OldHtbCeil;
        unsigned int MeasureRate;
	unsigned int Rate;
	unsigned int SfqPerturb;
        unsigned int EsfqPerturb;
        unsigned int HardLimit;
        unsigned int SoftLimit;
        unsigned int LocalSectionId;
        unsigned int SectionShape;
        double Strict; 
        bool UseIpt;  
        bool UseTcClass;
        bool UseTcFilter;
        bool SumInSection;
        bool StatsShowHtbCeil;
        bool StatsShowRate;
        bool Work;      
        filtertype Filter;
        qdisctype Qdisc;
        std::vector < TcFilter * > tcfilter;
        std::vector < char * > SectionIfaces;  
        std::vector < char * > MarkIfaces;  
};

#endif
