/*                                                                                                                                                                                 
 *      NiceShaper - Dynamic Traffic Management                                                                                                                                    
 *                                                                                                                                                                                 
 *      Copyright 2004 Mariusz Jedwabny <mariusz@jedwabny.net>                                                                                                              
 *                                                                                                                                                                                 
 *      This file is subject to the terms and conditions of the GNU General Public                                                                                                 
 *      License.  See the file COPYING in the main directory of this archive for                                                                                                   
 *      more details.                                                                                                                                                              
 */   

#include "error.h"

void Error::dump ( int mesid, const char bufline[LONG_BUF] )
{
    char buf[LONG_BUF]="", message[LONG_BUF]="";
    
    if      (( mesid == 11 ) && ( lang == pl )) strcat( message, "nieznany parametr" );
    else if (( mesid == 11 ) && ( lang == en )) strcat( message, "unknown parameter" );
    else if (( mesid == 12 ) && ( lang == pl )) strcat( message, "firewall uszkodzony!!!" );
    else if (( mesid == 12 ) && ( lang == en )) strcat( message, "firewall crashed!!!" );
    else if (( mesid == 13 ) && ( lang == pl )) strcat( message, "Bledny reload. Parametr musi byc z zakresu: (0.1s - 600s)" );
    else if (( mesid == 13 ) && ( lang == en )) strcat( message, "Wrong reload. Must be in range: (0.1s - 600s)" );
    else if (( mesid == 14 ) && ( lang == pl )) strcat( message, "Bdny iptable-hook" );
    else if (( mesid == 14 ) && ( lang == en )) strcat( message, "Wrong iptables-hook" );
    else if (( mesid == 15 ) && ( lang == pl )) strcat( message, "Brak sekcji do uruchomienia" );
    else if (( mesid == 15 ) && ( lang == en )) strcat( message, "Nothing to run" );
    else if (( mesid == 16 ) && ( lang == pl )) strcat( message, "Bdny interfejs" );
    else if (( mesid == 16 ) && ( lang == en )) strcat( message, "Not proper device" );
    else if (( mesid == 17 ) && ( lang == pl )) strcat( message, "Nie obsugiwany scheduler" );
    else if (( mesid == 17 ) && ( lang == en )) strcat( message, "Unrecognized scheduler" );
    else if (( mesid == 18 ) && ( lang == pl )) strcat( message, "Bdna podsie" );
    else if (( mesid == 18 ) && ( lang == en )) strcat( message, "Wrong network" );
    else if (( mesid == 19 ) && ( lang == pl )) strcat( message, "section speed jest wymagane" );
    else if (( mesid == 19 ) && ( lang == en )) strcat( message, "section speed is required" );    
    else if (( mesid == 20 ) && ( lang == pl )) strcat( message, "section shape jest wymagane" );
    else if (( mesid == 20 ) && ( lang == en )) strcat( message, "section shape is required" );
    else if (( mesid == 21 ) && ( lang == pl )) strcat( message, "iptables-hook jest wymagane" );
    else if (( mesid == 21 ) && ( lang == en )) strcat( message, "iptables-hook is required" );
    else if (( mesid == 22 ) && ( lang == pl )) strcat( message, "iface jest wymagane" );
    else if (( mesid == 22 ) && ( lang == en )) strcat( message, "iface is required" );
    else if (( mesid == 23 ) && ( lang == pl )) strcat( message, "przynajmniej jedna klasa jest wymagana" );
    else if (( mesid == 23 ) && ( lang == en )) strcat( message, "at least one class is required" );
    else if (( mesid == 24 ) && ( lang == pl )) strcat( message, "bad skadni" );
    else if (( mesid == 24 ) && ( lang == en )) strcat( message, "syntax error" );
    else if (( mesid == 25 ) && ( lang == pl )) strcat( message, "za dluga linia konfiguracji" );
    else if (( mesid == 25 ) && ( lang == en )) strcat( message, "config line is too long" );
    else if (( mesid == 26 ) && ( lang == pl )) strcat( message, "nie mozna czytac z pliku" );
    else if (( mesid == 26 ) && ( lang == en )) strcat( message, "cannot read file" );
    else if (( mesid == 27 ) && ( lang == pl )) strcat( message, "nie mozna pisac do pliku" );
    else if (( mesid == 27 ) && ( lang == en )) strcat( message, "cannot write to file" );
    else if (( mesid == 28 ) && ( lang == pl )) strcat( message, "bdne uycie parametru uruchomieniowego" );
    else if (( mesid == 28 ) && ( lang == en )) strcat( message, "runtime syntax error" );
    else if (( mesid == 29 ) && ( lang == pl )) strcat( message, "bdny adres ip" );
    else if (( mesid == 29 ) && ( lang == en )) strcat( message, "wrong ip address" );
    else if (( mesid == 30 ) && ( lang == pl )) strcat( message, "nie mozna bylo uruchomic sekcji" );
    else if (( mesid == 30 ) && ( lang == en )) strcat( message, "CANNOT start section" );
    else if (( mesid == 31 ) && ( lang == pl )) strcat( message, "Bdna jednostka transferu" );
    else if (( mesid == 31 ) && ( lang == en )) strcat( message, "Not proper unit" );
    else if (( mesid == 32 ) && ( lang == pl )) strcat( message, "Warto transferu nie moe by wysza od 1024mbit" );
    else if (( mesid == 32 ) && ( lang == en )) strcat( message, "Transfer can not be bigger than 1024mbit" );
    else if (( mesid == 33 ) && ( lang == pl )) strcat( message, "Podany interfejs nie naley do sekcji" );
    else if (( mesid == 33 ) && ( lang == en )) strcat( message, "Given interface is not within section" );
    else if (( mesid == 34 ) && ( lang == pl )) strcat( message, "Bdny stan" );
    else if (( mesid == 34 ) && ( lang == en )) strcat( message, "Invalid state" );
    else if (( mesid == 35 ) && ( lang == pl )) strcat( message, "Parametr proto jest wymagany dla portw" );
    else if (( mesid == 35 ) && ( lang == en )) strcat( message, "Proto is required to use ports" );
    else if (( mesid == 36 ) && ( lang == pl )) strcat( message, "Podany filtr wymaga markowania pakietw na interfejsie" );
    else if (( mesid == 36 ) && ( lang == en )) strcat( message, "Given filter requires mark on iface" );
    else if (( mesid == 37 ) && ( lang == pl )) strcat( message, "Filtr u32 wymaga maski sieciowej cigej bitowo" );
    else if (( mesid == 37 ) && ( lang == en )) strcat( message, "Use solid netmask with u32 filter" );
    else if (( mesid == 38 ) && ( lang == pl )) strcat( message, "Nie odnaleziono otwarcia sekcji" );
    else if (( mesid == 38 ) && ( lang == en )) strcat( message, "Can't find section opening tag" );
    else if (( mesid == 39 ) && ( lang == pl )) strcat( message, "Nie odnaleziono zamknicia sekcji" );
    else if (( mesid == 39 ) && ( lang == en )) strcat( message, "Can't find section ending tag" );
    else if (( mesid == 40 ) && ( lang == pl )) strcat( message, "Section shape jest wiksze od section speed" );
    else if (( mesid == 40 ) && ( lang == en )) strcat( message, "Section shape is bigger than section speed" );
    else if (( mesid == 41 ) && ( lang == pl )) strcat( message, "Strict musi si mieci w przedziale 0-100%" );
    else if (( mesid == 41 ) && ( lang == en )) strcat( message, "Strict must be between 0-100%" );
    else if (( mesid == 42 ) && ( lang == pl )) strcat( message, "Komunikacja z procesem potomnych nie powioda si" );
    else if (( mesid == 42 ) && ( lang == en )) strcat( message, "Read from child process failed" );
    else if (( mesid == 43 ) && ( lang == pl )) strcat( message, "Komunikacja z procesem gownym nie powioda si" );
    else if (( mesid == 43 ) && ( lang == en )) strcat( message, "Write to master process failed" );

    if ( strlen(bufline)) sprintf( buf, "<%s>: %s: %s", section, message, bufline );		
    else sprintf( buf, "<%s>: %s", section, message );		

    log( buf );
    
    FatalError = true;

    return;
}

void Warning::dump ( int mesid, const char bufline[LONG_BUF] ) 
{
    char buf[LONG_BUF]="", message[LONG_BUF]="";

    if (( mesid == 1 ) && ( lang == pl )) strcat( message, "Podana opcja jest przestarzaa" );
    else if (( mesid == 1 ) && ( lang == en )) strcat( message, "Given option is deprecated" );
    else if (( mesid == 2 ) && ( lang == pl )) strcat( message, "Uzyto niestandardowego acucha iptables" );
    else if (( mesid == 2 ) && ( lang == en )) strcat( message, "Probably wrong iptables hook" );
    else if (( mesid == 3 ) && ( lang == pl )) strcat( message, "Brak parametru download-section, uyto wartoci domylnej" );
    else if (( mesid == 3 ) && ( lang == en )) strcat( message, "Missing download-section parameter, using default" );
    else if (( mesid == 4 ) && ( lang == pl )) strcat( message, "Brak parametru upload-section, uyto wartoci domylnej" );
    else if (( mesid == 4 ) && ( lang == en )) strcat( message, "Missing upload-section parameter, using default" );
    else if (( mesid == 5 ) && ( lang == pl )) strcat( message, "Brak parametru, uyto wartoci domylnej" );
    else if (( mesid == 5 ) && ( lang == en )) strcat( message, "Missing parameter, using default" );
    else if (( mesid == 6 ) && ( lang == pl )) strcat( message, "Brak parametru, klasy nie zostan utworzone" );
    else if (( mesid == 6 ) && ( lang == en )) strcat( message, "Missing parameter, not attempt to generate classess" );
    else if (( mesid == 7 ) && ( lang == pl )) strcat( message, "Podana opcja jest przestarzaa, uyj iptables hook" );
    else if (( mesid == 7 ) && ( lang == en )) strcat( message, "Given option is deprecated, use iptables hook instead" );
    else if (( mesid == 8 ) && ( lang == pl )) strcat( message, "Podana opcja jest przestarzaa, uyj imq autoredirect [true|false]" );
    else if (( mesid == 8 ) && ( lang == en )) strcat( message, "Given option is deprecated, use imq autoredirect [true|false]" );

    if ( strlen(bufline)) sprintf( buf, "<%s>: %s: %s", section, message, bufline );		
    else sprintf( buf, "<%s>: %s", section, message );		
    
    log( buf );    
}

void Info::dump ( int mesid, const char bufline[LONG_BUF] ) 
{
    char buf[LONG_BUF]="", message[LONG_BUF]="";
    
    if (( mesid == 1 ) && ( lang == pl )) strcat( message, "Start" );
    else if (( mesid == 1 ) && ( lang == en )) strcat( message, "Start" );
    else if (( mesid == 2 ) && ( lang == pl )) strcat( message, "Stop" );
    else if (( mesid == 2 ) && ( lang == en )) strcat( message, "Stop" );
    else if (( mesid == 3 ) && ( lang == pl )) strcat( message, "Uruchamianie sekcji..." );
    else if (( mesid == 3 ) && ( lang == en )) strcat( message, "Starting section ..." );

    if ( strlen(bufline)) sprintf( buf, "<%s>: %s: %s", section, message, bufline );		
    else sprintf( buf, "<%s>: %s", section, message );		

    log( buf );
}

void Debug::log (char message[LONG_BUF])
{
    onTerminal( message );
    toSyslog( message );
    toLogFile( message );
}
            
void Debug::onTerminal (char message[LONG_BUF])
{
    if ( !LogOnTerminal ) return;
    
    if ( !DoNotPutTabChar && !DoNotPutNewLineChar ) {
    	printf( "\t%s\n", message );
    }
    if ( DoNotPutTabChar && DoNotPutNewLineChar ) {
	printf( "%s", message );
	DoNotPutTabChar = false;
	DoNotPutNewLineChar = false;
    }	
    else if ( DoNotPutNewLineChar ) {
	printf( "\t%s", message );
	DoNotPutNewLineChar = false;
    }	
    else if ( DoNotPutTabChar ) {
	printf( "%s\n", message );
	DoNotPutTabChar = false;
    }	
    
    fflush( stdout );
}
                    
void Debug::toSyslog ( char message[LONG_BUF])
{
    if ( !LogToSyslog ) return;

    setlogmask (LOG_UPTO (LOG_NOTICE));
    openlog ("niceshaper", LOG_PID | LOG_NDELAY, LOG_LOCAL1);
    syslog (LOG_NOTICE, message, getuid ());
    closelog();
}

void Debug::toLogFile ( char message[LONG_BUF] )
{
    int fd;
    
    if ( !LogToFile ) return;
    
    fd = open( LogFile, O_CREAT | O_WRONLY | O_APPEND );
    write( fd, message, strlen(message));
    write( fd, "\n", 1 );
    close(fd);
}
