#ifndef DEBUG_H
#define DEBUG_H

#include <syslog.h> 
#include "main.h"

class Debug
{
    public:
        Debug () { DoNotPutNewLineChar = false; DoNotPutTabChar = false; LogOnTerminal = true; LogToSyslog = true; LogToFile = false; strncpy ( LogFile, "", MAX_PATH+1); };
        virtual ~Debug () {};
        virtual void dump ( int, const char []) = 0;    
        void onTerminal (char []);
        void toSyslog (char []);
        void toLogFile (char []);
        void log (char []);
        void setDoNotPutNewLineChar() { DoNotPutNewLineChar = true; };
        void setDoNotPutTabChar() { DoNotPutTabChar = true; };
        void setLogOnTerminal ( bool log_on_terminal ) { LogOnTerminal = log_on_terminal; };
        void setLogToSyslog ( bool log_to_syslog ) { LogToSyslog = log_to_syslog; };
        void setLogToFile ( bool log_to_file ) { LogToFile = log_to_file; };
        void setLogFile ( char log_file[] ) { strncpy( LogFile, log_file, MAX_PATH ); };
    private:
	bool LogOnTerminal;
        bool LogToSyslog;
	bool LogToFile;
        bool DoNotPutNewLineChar;
        bool DoNotPutTabChar;
        char LogFile[MAX_PATH+1];
};

class Error : public Debug
{
    public:
	void dump ( int, const char []);
	void markFatalError () { FatalError = true; };
	bool fatalError () { return FatalError; };
    private:
	bool FatalError;
};

class Warning : public Debug
{
    public:
	void dump ( int, const char []);
    private:
};

class Info : public Debug
{
    public:
	void dump ( int, const char []);
    private:
};

#endif
