#ifndef TCFILTER_H
#define TCFILTER_H

#include "main.h"
#include "aux.h"
#include "error.h"
#include "sys.h"
#include "tests.h"

class TcFilter {
    public:
	TcFilter( char[], char[], filtertype );
        ~TcFilter();
        int store( char[] );
        int prepareTcFilter();
        int envInit();
        unsigned int add(); 
        unsigned int del();
        unsigned int check( std::vector  < char * > & );
    private:
        char Dev[MAX_IFACE+1];
        char TcFilterAdd[LONG_BUF];
        char TcFilterDel[LONG_BUF];
        char IptMatch[LONG_BUF];
        char Match[LONG_BUF];
        unsigned int FilterId;
        unsigned int HandleFw;
        unsigned int FlowId;
        unsigned int Chains;
        bool ImqAutoRedirect;
        bool DestMark;
        bool FromLocalhost;
        bool ToLocalhost;
        bool UseTcFilter;
        bool UseForFw;
        filtertype Filter;
        ipt_targettype IptTarget; 
};

#endif
