#ifndef MAIN_H
#define MAIN_H

#define version "0.6rc8"

#include <cstdlib>
#include <cstring>	
#include <cstdio> 
#include <signal.h>		
#include <sys/wait.h>
#include <fcntl.h>		
#include <netdb.h>		
#include <sys/time.h>		
#include <sys/types.h>		
#include <iostream>
#include <vector>
#include <stdio.h>

using namespace std;

const unsigned int LONG_BUF = 1024;
const unsigned int SHORT_BUF = 64;
const unsigned int STAT_MESSAGE_BUF = 80;
const unsigned int LONG_IP_ADDR = 32;
const unsigned int SHORT_IP_ADDR = 15;
const unsigned int MAX_IFACE = 12;
const unsigned int MAX_PATH = 256;
const unsigned int MAX_NAME = 32;
const char ACK = 39; // '
const char NAK = 33; // ! 
const char EOT = 36; // $
const unsigned int PROTO_BASE = 40;

enum unittype { bps = 8, kbps = 8192, mbps = 8388608, bit = 1, kbit = 1024, mbit = 1048576 };
enum filtertype { u32 = 1, fw = 2 };
enum classtype { standard = 1, donotshape = 2, virtualclass = 3, wrapper = 4 };
enum qdisctype { none = 1, sfq = 2, esfq = 3 };
enum langtype { en = 1 , pl = 2 };
enum filetype { conftype = 1 , classtype = 2 };
enum ipt_targettype { t_accept = 1, t_return = 2, t_drop = 3, t_empty = 4 };
enum statsclassestype { c_all = 1, c_active = 2, c_working = 3, c_false = 4 };
enum statssumtype { s_top = 1, s_bottom = 2, s_false = 3 };

extern char section[MAX_NAME+1];
extern char ipt_mychain[SHORT_BUF];

extern unsigned int section_id;
extern unsigned int working;
extern langtype lang;
extern bool i_am_parent;

extern class Error *error;
extern class Warning *warning;
extern class Info *info;
extern class Tests *test;
extern class Sys *sys;

void run(int, char *[]);
void start_quit_seq(); 
void signalterm(int);
void signalstats(int);
void help();

#endif
