#ifndef NICESHAPER_H
#define NICESHAPER_H

#include "main.h"
#include "class.h"
#include "error.h"
#include "net.h"
#include "sys.h"
#include "tests.h"

using namespace std;

class NiceShaper {
    public:
	NiceShaper();
        ~NiceShaper();
        int init( vector < char * > &, vector < char * > &, vector < unsigned int > & );
        int judge();    
        void stats(int); // write to pipe, pointed by file descriptor
        unsigned int reload() { return Reload; };
    private:
	// permanent values
	unsigned int SectionHtbCeil;
	unsigned int SectionShape;
        unsigned int Reload;
        char IptMyParent[SHORT_BUF+1];
        char IptMyParentMode[SHORT_BUF+1];
        vector < char * > SectionIfaces;
        vector < char * > MarkIfaces;
	// variable values
        unsigned int SectionRate;
        unsigned int SectionMeasureRate;
        unsigned int MaxPotentialSectionRate;
        unsigned int ChangeableSectionRate;
        unsigned int Working;
        struct timeval Ltt;    
        double CrossBar;     
	vector < Net * > net;
        vector < TcClass * > tcclass;
	vector < TcClass * > WorkingClass;
        vector < TcClass * > ChangeableClass;
        statsclassestype StatsClasses;
        statssumtype StatsSum;
        int checkIptables();
        int applyChanges();  
};

#endif


